/* Copyright 2014 Adobe Systems Incorporated (http://www.adobe.com/). All Rights Reserved.
This software is licensed as OpenSource, under the Apache License, Version 2.0. This license is available at: http://opensource.org/licenses/Apache-2.0. *//***********************************************************************
 * SCCS Id:    %W%
 * Changed:    %G% %U%
 ***********************************************************************/

/*
 * Standard encoding aggregate initializer. Element values are encodings 
 * (index by SID).
 */

#ifndef STDENCCD_H
#define STDENCCD_H

	 -1,	/*   0 .notdef */
	 32,	/*   1 space */
	 33,	/*   2 exclam */
	 34,	/*   3 quotedbl */
	 35,	/*   4 numbersign */
	 36,	/*   5 dollar */
	 37,	/*   6 percent */
	 38,	/*   7 ampersand */
	 39,	/*   8 quoteright */
	 40,	/*   9 parenleft */
	 41,	/*  10 parenright */
	 42,	/*  11 asterisk */
	 43,	/*  12 plus */
	 44,	/*  13 comma */
	 45,	/*  14 hyphen */
	 46,	/*  15 period */
	 47,	/*  16 slash */
	 48,	/*  17 zero */
	 49,	/*  18 one */
	 50,	/*  19 two */
	 51,	/*  20 three */
	 52,	/*  21 four */
	 53,	/*  22 five */
	 54,	/*  23 six */
	 55,	/*  24 seven */
	 56,	/*  25 eight */
	 57,	/*  26 nine */
	 58,	/*  27 colon */
	 59,	/*  28 semicolon */
	 60,	/*  29 less */
	 61,	/*  30 equal */
	 62,	/*  31 greater */
	 63,	/*  32 question */
	 64,	/*  33 at */
	 65,	/*  34 A */
	 66,	/*  35 B */
	 67,	/*  36 C */
	 68,	/*  37 D */
	 69,	/*  38 E */
	 70,	/*  39 F */
	 71,	/*  40 G */
	 72,	/*  41 H */
	 73,	/*  42 I */
	 74,	/*  43 J */
	 75,	/*  44 K */
	 76,	/*  45 L */
	 77,	/*  46 M */
	 78,	/*  47 N */
	 79,	/*  48 O */
	 80,	/*  49 P */
	 81,	/*  50 Q */
	 82,	/*  51 R */
	 83,	/*  52 S */
	 84,	/*  53 T */
	 85,	/*  54 U */
	 86,	/*  55 V */
	 87,	/*  56 W */
	 88,	/*  57 X */
	 89,	/*  58 Y */
	 90,	/*  59 Z */
	 91,	/*  60 bracketleft */
	 92,	/*  61 backslash */
	 93,	/*  62 bracketright */
	 94,	/*  63 asciicircum */
	 95,	/*  64 underscore */
	 96,	/*  65 quoteleft */
	 97,	/*  66 a */
	 98,	/*  67 b */
	 99,	/*  68 c */
	100,	/*  69 d */
	101,	/*  70 e */
	102,	/*  71 f */
	103,	/*  72 g */
	104,	/*  73 h */
	105,	/*  74 i */
	106,	/*  75 j */
	107,	/*  76 k */
	108,	/*  77 l */
	109,	/*  78 m */
	110,	/*  79 n */
	111,	/*  80 o */
	112,	/*  81 p */
	113,	/*  82 q */
	114,	/*  83 r */
	115,	/*  84 s */
	116,	/*  85 t */
	117,	/*  86 u */
	118,	/*  87 v */
	119,	/*  88 w */
	120,	/*  89 x */
	121,	/*  90 y */
	122,	/*  91 z */
	123,	/*  92 braceleft */
	124,	/*  93 bar */
	125,	/*  94 braceright */
	126,	/*  95 asciitilde */
	161,	/*  96 exclamdown */
	162,	/*  97 cent */
	163,	/*  98 sterling */
	164,	/*  99 fraction */
	165,	/* 100 yen */
	166,	/* 101 florin */
	167,	/* 102 section */
	168,	/* 103 currency */
	169,	/* 104 quotesingle */
	170,	/* 105 quotedblleft */
	171,	/* 106 guillemotleft */
	172,	/* 107 guilsinglleft */
	173,	/* 108 guilsinglright */
	174,	/* 109 fi */
	175,	/* 110 fl */
	177,	/* 111 endash */
	178,	/* 112 dagger */
	179,	/* 113 daggerdbl */
	180,	/* 114 periodcentered */
	182,	/* 115 paragraph */
	183,	/* 116 bullet */
	184,	/* 117 quotesinglbase */
	185,	/* 118 quotedblbase */
	186,	/* 119 quotedblright */
	187,	/* 120 guillemotright */
	188,	/* 121 ellipsis */
	189,	/* 122 perthousand */
	191,	/* 123 questiondown */
	193,	/* 124 grave */
	194,	/* 125 acute */
	195,	/* 126 circumflex */
	196,	/* 127 tilde */
	197,	/* 128 macron */
	198,	/* 129 breve */
	199,	/* 130 dotaccent */
	200,	/* 131 dieresis */
	202,	/* 132 ring */
	203,	/* 133 cedilla */
	205,	/* 134 hungarumlaut */
	206,	/* 135 ogonek */
	207,	/* 136 caron */
	208,	/* 137 emdash */
	225,	/* 138 AE */
	227,	/* 139 ordfeminine */
	232,	/* 140 Lslash */
	233,	/* 141 Oslash */
	234,	/* 142 OE */
	235,	/* 143 ordmasculine */
	241,	/* 144 ae */
	245,	/* 145 dotlessi */
	248,	/* 146 lslash */
	249,	/* 147 oslash */
	250,	/* 148 oe */
	251,	/* 149 germandbls */

#endif /* STDENCCD_H */
